#ifndef COMMUNICATION_APP_H
#define COMMUNICATION_APP_H

#include "BaseApplLayer.h"

/**
 * @brief Application class for legal nodes
 *
 * The class is not currently used.
 *
 * @author Radim Ostadal
 **/
class MIXIM_API CommunicationApp : public BaseApplLayer {

    protected:
        /** @brief Debug switch */
        bool debug;

        /** @brief Number of legitimate nodes in the network */
        int numNodes;

        /** @brief Length of the application message header (in bits) */
        int headerLength;

        /** @brief Types used for of self messages */
        enum SelfMessageTypes {
            // TODO
        };

        /** @brief Communication pattern types used in the network */
        enum PatternTypes {
            // TODO
        };

    private:
        /** @brief Copy constructor is not allowed */
        CommunicationApp(const CommunicationApp&);

        /** @brief Assignment operator is not allowed */
        CommunicationApp& operator=(const CommunicationApp&);

    public:
        CommunicationApp();
        virtual ~CommunicationApp();

        /** @brief Initialization of variables, activity planned using timers */
        virtual void initialize(int stage);

        /** @brief Function handling  messages generated by the timers */
        virtual void handleSelfMsg(cMessage* msg);

        /** @brief Function handling messages from other nodes */
        virtual void handleLowerMsg(cMessage*);
};

#endif
