#include "NeighbourPredistribution.h"

Define_Module(NeighbourPredistribution);

NeighbourPredistribution::NeighbourPredistribution()
    : BaseKE()
{}

void NeighbourPredistribution::initialize(int stage) {
    BaseKE::initialize(stage);

    if (stage == 0) {

    } else if (stage == 1) {
        // Set the timer to start just before the attacker initial compromise (default time 0, priority 1)
        cMessage * keyEstablishmentTimer = new cMessage("keStart", KE_INIT_KEYS);
        keyEstablishmentTimer->setSchedulingPriority(0);
        scheduleAt(0, keyEstablishmentTimer);
    }
}

void NeighbourPredistribution::handleSelfMsg(cMessage* msg) {
    if (msg->getKind() == KE_INIT_KEYS) {
       predistNeighbourKeys();
    }

    delete msg;
}

void NeighbourPredistribution::predistNeighbourKeys() {
    // Get keys only for my neighbors
    cModule::GateIterator * neighbourGates = new cModule::GateIterator(getParentModule()->getParentModule());
    for (; !neighbourGates->end(); (*neighbourGates)++) {
        cGate *gate = (*neighbourGates) ();
        cGate *otherGate = gate->getType() == cGate::OUTPUT ? gate->getNextGate() : NULL;
        if (otherGate) {
            int neighbourIndex = otherGate->getOwnerModule()->getIndex();
            setKey(neighbourIndex, getDataModule()->getPredistributedKey(neighbourIndex));
        }
    }
}

NeighbourPredistribution::~NeighbourPredistribution() {

}
