#ifndef STATIC_MOBILITY_H
#define STATIC_MOBILITY_H

#include <StationaryMobility.h>

/**
 * @brief Mobility class that is used for legitimate nodes
 *
 * Mobility class adds the possibility to set the position of legitimate node.
 *
 * @author Filip Jurnečka
 **/
class StaticMobility : public StationaryMobility {

    private:
        /** @brief Copy constructor is not allowed */
        StaticMobility(const StaticMobility&);

        /** @brief Assignment operator is not allowed */
        StaticMobility& operator = (const StaticMobility&);

    public:
        StaticMobility();
        virtual ~StaticMobility();

        /** @brief Initialization of variables, activity planned using timers */
        virtual void initialize(int stage);

        /** @brief Set the new node position */
        void setPosition(Coord pos);
};

#endif
