#ifndef UTILFUNCTIONS_H
#define UTILFUNCTIONS_H

#include "Data.h"

/** @brief Returns the bool value (true if nodeA and nodeB are neighbours, false otherwise) */
bool areNodesNeighbours(cModule * nodeA, cModule * nodeB);

/** @brief Returns the bool value (true if nodeA and nodeB share the key, false otherwise) */
bool existsSharedKeyBetween(int nodeIndexA, Data * dataA, int nodeIndexB, Data * dataB);

/** @brief Returns random number key of provided length */
void rndArray(Key key, int length);

/** @brief Prints the key in hex format */
void keyToHex(Key key, int keyLength);

/** @brief Compute the nonce hashe */
unsigned int SHA256int(unsigned char * input, int inputLength);

/** @brief Compute the SHA-256 fingerprint from input parameter */
Key SHA256(unsigned char * input, int inputLength);

#endif
